using System;
using System.Collections;
using System.Windows.Forms;


namespace TestWeakReference
{
	public class WeakControl : System.Windows.Forms.Panel
	{
    static ArrayList mAllWeaks = new ArrayList();

		public WeakControl()
		{
      mAllWeaks.Add( new WeakReference(this,false) );
		}

    static public int GetCount() {
      GC.Collect();
      ArrayList mKilledWeaks = new ArrayList();

      foreach(WeakReference co in mAllWeaks) {
        if( !co.IsAlive ) mKilledWeaks.Add(co);
      }

      foreach( WeakReference co in mKilledWeaks ) {
        mAllWeaks.Remove(co);
      }

      mKilledWeaks.Clear();
      mKilledWeaks = null;
      GC.Collect();

      return mAllWeaks.Count;

    }
	}
}
